local version = 1

if towerofheaven == nil then
	rawset(_G, "towerofheaven", {})
elseif version < towerofheaven.version then
	return -- Don't load the rest of the script.
end

towerofheaven.version = version

towerofheaven.ruleInits = {}
towerofheaven.loadRuleInits = function()
	if #towerofheaven.ruleInits <= 0 then return end
	for i = 1, #towerofheaven.ruleInits do
		towerofheaven.ruleInits[i]()
	end
end

towerofheaven.isHitFeedOn = false
towerofheaven.hitFeedIcon = "K_GODFL"
towerofheaven.setUpHitFeed = function()
	if towerofheaven.isHitFeedOn then return end
	if not hitfeed then return end
	
	HF_animIcon[towerofheaven.hitFeedIcon] = {2, 2}

	towerofheaven.isHitFeedOn = true
end

towerofheaven.turnCommaDelimitedStringIntoTable = function(string)
	if string == nil or string == "" then
		return {}, 0
	end

	local tableVar = {}
	local newString = ""
	local numThingsAdded = 0
	for i = 1, #string do
		local c = string:sub(i,i)
		
		if c == ',' then
			table.insert(tableVar, newString)
			numThingsAdded = $ + 1
			newString = ""
		else
			newString = $..c
		end
	end

	if newString ~= "" then
		table.insert(tableVar, newString)
		numThingsAdded = $ + 1
	end

	return tableVar, numThingsAdded
end

-- How many players are there in-game.
towerofheaven.pInGame = function()
	local pingame = 0
	for p in players.iterate do
		if p.spectator then continue end
		pingame = $ + 1
	end
	return pingame
end